
//	HID Minidriver for Microsoft Xbox 360 Wireless Controller

#include	"driver.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ
//----------------------------------------------------------------------------------------------

UCHAR	ControllerCount;
UCHAR	LimitationMode;

//----------------------------------------------------------------------------------------------
//	DriverEntry
//----------------------------------------------------------------------------------------------
DRIVER_INITIALIZE DriverEntry;
NTSTATUS DriverEntry(
	 IN PDRIVER_OBJECT	DriverObject
	,IN PUNICODE_STRING	RegistryPath )
{
	//	ϐ錾
	NTSTATUS					Status;
	SETTING						Setting;
	HID_MINIDRIVER_REGISTRATION	HIDMiniDriverRegistration;

	//	hCo Gg |Cgݒ肷
	DriverObject->DriverExtension->AddDevice					= AddDevice;
	DriverObject->DriverUnload									= DriverUnload;
	DriverObject->MajorFunction[IRP_MJ_INTERNAL_DEVICE_CONTROL]	= InternalDeviceControl;
	DriverObject->MajorFunction[IRP_MJ_PNP]						= PnP;
	DriverObject->MajorFunction[IRP_MJ_POWER]					= Power;

	//	ݒ擾
	LoadSetting( &Setting );
	ControllerCount	= Setting.ControllerCount;
	LimitationMode	= Setting.LimitationMode;

	//	HID Minidriver o^
	RtlZeroMemory( &HIDMiniDriverRegistration, sizeof( HIDMiniDriverRegistration ) );
	HIDMiniDriverRegistration.Revision				= HID_REVISION;
	HIDMiniDriverRegistration.DriverObject			= DriverObject;
	HIDMiniDriverRegistration.RegistryPath			= RegistryPath;
	HIDMiniDriverRegistration.DeviceExtensionSize	= sizeof( DEVICE_EXTENSION );
	HIDMiniDriverRegistration.DevicesArePolled		= FALSE;
	Status	= HidRegisterMinidriver( &HIDMiniDriverRegistration );

	return( Status );
}
